using System;
using System.Collections.Generic;

namespace XamPivotGridXampl
{
    public class AggregateBucketRiskServices : IBucketRiskService
    {
        private readonly IEnumerable<IBucketRiskService> _services;

        public AggregateBucketRiskServices(IEnumerable<WcfBucketRiskWrapper> services)
        {
            _services = services;
        }

        public IEnumerable<BucketRiskDTO> GetAll()
        {
            return GetBucketRiskDTOs(service => service.GetAll());
        }

        public IEnumerable<BucketRiskDTO> GetAll(string profile)
        {
            return GetBucketRiskDTOs(service => service.GetAll(profile));
        }

        private IEnumerable<BucketRiskDTO> GetBucketRiskDTOs(Func<IBucketRiskService, IEnumerable<BucketRiskDTO>> serviceAction)
        {
            var bucketRiskDTOs = new List<BucketRiskDTO>();
            foreach (var bucketRiskService in _services)
            {
                bucketRiskDTOs.AddRange(serviceAction(bucketRiskService));
            }
            return bucketRiskDTOs;
        }
    }
}