using System;
using System.Windows.Input;

namespace XamPivotGridXampl
{
    public class BucketRiskChangeLayoutCommand : ICommand
    {
        private readonly BucketRiskLayoutManager _layoutManager;
        private readonly GuiHelper _guiHelper;

        public BucketRiskChangeLayoutCommand(BucketRiskLayoutManager layoutManager, GuiHelper guiHelper)
        {
            _layoutManager = layoutManager;
            _guiHelper = guiHelper;
        }

        public bool CanExecute(object parameter)
        {
            return _layoutManager.CanChangeLayout;
        }

        public void Execute(object parameter)
        {
            var layoutItem = parameter as BucketRiskLayoutItemViewModel;
            if (layoutItem != null)
            {
                //_guiHelper.TryInvoke(() => _layoutManager.LoadCustomizations(layoutItem.Layout));

                //Task.Factory.StartNew(() =>
                //{
                //    _layoutManager.CanChangeLayout = false;
                //    _guiHelper.TryInvoke(() => _layoutManager.FlatDataSource.LoadCustomizations(layoutItem.Layout));

                //}).ContinueWith(delegate { _layoutManager.CanChangeLayout = true; });
                _guiHelper.TryInvoke(() => _layoutManager.LoadLayoutInner(layoutItem.Layout));
                _guiHelper.TryInvoke(() => _layoutManager.CanChangeLayout = true);

            }

        }

        public event EventHandler CanExecuteChanged;
    }
}