using System;
using System.Collections.Generic;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;

namespace XamPivotGridXampl
{
    public class BucketRiskFlatDataSource : FlatDataSource, IFlatDataSource<BucketRiskDTO>
    {
        event EventHandler<EventArgs> IFlatDataSource<BucketRiskDTO>.ResultChanged
        {
            add { ResultChanged += OnResultChanged(value); }
            remove { ResultChanged -= OnResultChanged(value); }
        }

        public void RefreshDataSource(IEnumerable<BucketRiskDTO> dataItems)
        {
            var layout = this.SaveCustomizations();
            ItemsSource = dataItems;
            this.LoadCustomizations(layout);
        }

        private static EventHandler<ResultChangedEventArgs> OnResultChanged(EventHandler<EventArgs> value)
        {
            return (sender, args) => value(sender, args);
        }

    }
}