using System;
using System.Collections.Generic;
using System.Windows.Input;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;

namespace XamPivotGridXampl
{
    public class BucketRiskLayoutManager : Bindable
    {
        private readonly GuiHelper _guiHelper;

        public ICommand SaveLayoutCommand { get; protected set; }
        public ICommand ChangeLayoutCommand { get; protected set; }

        public BucketRiskLayoutManager(GuiHelper guiHelper, BucketRiskFlatDataSource flatDataSource)
        {
            _guiHelper = guiHelper;
            FlatDataSource = flatDataSource;
            Layouts = new BucketRiskLayoutReader(this).Read();
            ChangeLayoutCommand = new BucketRiskChangeLayoutCommand(this, guiHelper);
            CanChangeLayout = true;
        }

        private bool _canChangeLayout;
        public bool CanChangeLayout
        {
            get { return _canChangeLayout; }
            set
            {
                if (_canChangeLayout == value)
                {
                    return;
                }

                _canChangeLayout = value;
                OnPropertyChanged();
            }
        }

        public void LoadLayoutInner(string layoutContent)
        {
            CanChangeLayout = false;
            try
            {
                FlatDataSource.LoadCustomizations(layoutContent);
            }
            catch (Exception e)
            {

            }
            finally
            {
                //CanChangeLayout = true;
            }
        }

        public FlatDataSource FlatDataSource { get; private set; } 

        public IEnumerable<BucketRiskLayoutItemViewModel> Layouts { get; private set; }
    }
}