using System;
using System.Collections.Generic;
using System.IO;
using System.Xml.Serialization;

namespace XamPivotGridXampl
{
    public interface IBucketRiskService
    {
        IEnumerable<BucketRiskDTO> GetAll();
        IEnumerable<BucketRiskDTO> GetAll(string profile);
    }

    public class BucketRiskServiceMock : IBucketRiskService
    {
        private readonly Lazy<BucketRiskDTO[]> _bucketRiskDtos = new Lazy<BucketRiskDTO[]>(GetResponse);

        private static BucketRiskDTO[] GetResponse()
        {
            var serviceResponse = Properties.Resources.BucketRiskServiceResponse;
            var serializer = new XmlSerializer(typeof (BucketRiskDTO[]));
            using (var streamReader = new StringReader(serviceResponse))
            {
                return (BucketRiskDTO[]) serializer.Deserialize(streamReader);
            }
        }

        public IEnumerable<BucketRiskDTO> GetAll()
        {
            return _bucketRiskDtos.Value;
        }

        public IEnumerable<BucketRiskDTO> GetAll(string profile)
        {
            return GetAll();
        }
    }
}