using System;
using System.Windows.Threading;

namespace XamPivotGridXampl
{
    public class GuiHelper
    {
        private readonly DispatcherPriority _priority;
        private readonly Dispatcher _dispatcher;

        public GuiHelper() : this(Dispatcher.CurrentDispatcher)
        {
        }

        public GuiHelper(Dispatcher dispatcher) : this(dispatcher, DispatcherPriority.SystemIdle)
        {
        }

        public GuiHelper(Dispatcher dispatcher, DispatcherPriority priority)
        {
            _dispatcher = dispatcher;
            _priority = priority;
        }

        public void TryInvoke(Action action)
        {
            if (_dispatcher.CheckAccess())
            {
                action();
            }
            else
            {
                _dispatcher.BeginInvoke(action, _priority);
            }
        }
    }
}