using System.Xml.Serialization;

namespace XamPivotGridXampl
{
    [XmlInclude(typeof(Swap))]
    [XmlInclude(typeof(Bond))]
    public class Instrument
    {
        public string Key { get; set; }
        public string Type { get; set; }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }
            if (ReferenceEquals(this, obj))
            {
                return true;
            }
            return obj.GetType() == GetType() && Equals((Instrument)obj);
        }

        protected bool Equals(Instrument other)
        {
            return string.Equals(Key, other.Key) && string.Equals(Type, other.Type);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                return ((Key != null ? Key.GetHashCode() : 0) * 397) ^ (Type != null ? Type.GetHashCode() : 0);
            }
        }
    }
}