using System;
using System.Collections.Generic;

namespace XamPivotGridXampl
{
    public class WcfBucketRiskWrapper : IBucketRiskService
    {
        private readonly IBucketRiskService _bucketRiskService;
        private readonly IBucketRiskExtractor _bucketRiskExtractor;

        public WcfBucketRiskWrapper(IBucketRiskService bucketRiskService, string serviceName)
            : this(bucketRiskService, new BucketRiskExtractorProvider(), serviceName)
        {
        }

        internal WcfBucketRiskWrapper(IBucketRiskService bucketRiskService, IBucketRiskExtractorProvider riskExtractorProvider, string serviceName)
        {
            _bucketRiskService = bucketRiskService;
            _bucketRiskExtractor = riskExtractorProvider.Get(serviceName);
        }

        public IEnumerable<BucketRiskDTO> GetAll()
        {
            return SafeExecuteServiceMethod(() => _bucketRiskExtractor.GetRisks(_bucketRiskService.GetAll()));
        }

        public IEnumerable<BucketRiskDTO> GetAll(string profile)
        {
            return SafeExecuteServiceMethod(() => _bucketRiskExtractor.GetRisks(_bucketRiskService.GetAll(profile)));
        }

        private static IEnumerable<BucketRiskDTO> SafeExecuteServiceMethod(Func<IEnumerable<BucketRiskDTO>> serviceMethod)
        {
            //try
            //{
            //    return serviceMethod();
            //}
            //catch (FaultException faultException)
            //{
            //    throw BucketRiskServiceExceptionFactory.CreateBucketRiskServiceException(faultException.Message);
            //}
            //catch (AggregateException aggregateException)
            //{
            //    if (aggregateException.InnerExceptions.Any(_ => _.GetType() == typeof(FaultException<ExceptionDetail>)))
            //    {
            //        throw BucketRiskServiceExceptionFactory.CreateBucketRiskServerDownException();
            //    }
            //    throw BucketRiskServiceExceptionFactory.CreateBucketRiskServiceUnexpectedException();
            //}
            //catch (TimeoutException timeoutException)
            //{
            //    throw BucketRiskServiceExceptionFactory.CreateBucketRiskServiceTimeOutException();
            //}
            //catch (EndpointNotFoundException)
            //{
            //    throw BucketRiskServiceExceptionFactory.CreateBucketRiskServerDownException();
            //}

            return serviceMethod();
        }
    }
}